## gtsam 4.2.0%2Bdfsg

=== tests/CMakeLists.txt ===
# exclude certain files
# note the source dir on each 
set (tests_exclude "")

if (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang") # might not be best test - Richard & Jason & Frank
	# clang linker segfaults on large testSerializationSlam 
	list (APPEND tests_exclude "testSerializationSlam.cpp") 
endif()

# Build tests
gtsamAddTestsGlob(tests "test*.cpp" "${tests_exclude}" "gtsam")

if(MSVC)
	set_property(SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/testSerializationSlam.cpp"
		APPEND PROPERTY COMPILE_FLAGS "/bigobj")
endif()

=== wrap/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

# Set the project name and version
project(gtwrap VERSION 1.0)

# ##############################################################################
# General configuration

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/GtwrapUtils.cmake)
gtwrap_get_python_version(${WRAP_PYTHON_VERSION})

# Set the variables to be used for the cmake config file.
if(WIN32 AND NOT CYGWIN)
  set(INSTALL_CMAKE_DIR CMake/${PROJECT_NAME})
else()
  set(INSTALL_CMAKE_DIR lib/cmake/${PROJECT_NAME})
endif()

set(INSTALL_LIB_DIR lib/${PROJECT_NAME})
set(INSTALL_BIN_DIR bin/${PROJECT_NAME})
set(INSTALL_INCLUDE_DIR include/${PROJECT_NAME})

# ##############################################################################
# Package Configuration

# Helper functions for generating the gtwrapConfig.cmake file correctly.
include(CMakePackageConfigHelpers)

# Configure the config file which is used for `find_package`.
configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/gtwrapConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake/gtwrapConfig.cmake
  INSTALL_DESTINATION "${INSTALL_CMAKE_DIR}"
  PATH_VARS INSTALL_CMAKE_DIR INSTALL_LIB_DIR INSTALL_BIN_DIR
            INSTALL_INCLUDE_DIR
  INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Set all the install paths
set(GTWRAP_CMAKE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${INSTALL_CMAKE_DIR})
set(GTWRAP_LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR})
set(GTWRAP_BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${INSTALL_BIN_DIR})
set(GTWRAP_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR})

# ##############################################################################
# Install the package

# Install CMake scripts to the standard CMake script directory.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/gtwrapConfig.cmake
              cmake/MatlabWrap.cmake cmake/PybindWrap.cmake
              cmake/GtwrapUtils.cmake DESTINATION "${GTWRAP_CMAKE_INSTALL_DIR}")

# Configure the include directory for matlab.h This allows the #include to be
# either gtwrap/matlab.h, wrap/matlab.h or something custom.
if(NOT DEFINED GTWRAP_INCLUDE_NAME)
  set(GTWRAP_INCLUDE_NAME
      "gtwrap"
      CACHE INTERNAL "Directory name for Matlab includes")
endif()

configure_file(${PROJECT_SOURCE_DIR}/templates/matlab_wrapper.tpl.in
               ${PROJECT_SOURCE_DIR}/gtwrap/matlab_wrapper/matlab_wrapper.tpl)

# Install the gtwrap python package as a directory so it can be found  by CMake
# for wrapping.
install(DIRECTORY gtwrap DESTINATION "${GTWRAP_LIB_INSTALL_DIR}")

# Install pybind11 directory to `CMAKE_INSTALL_PREFIX/lib/gtwrap/pybind11` This
# will allow the gtwrapConfig.cmake file to load it later.
install(DIRECTORY pybind11 DESTINATION "${GTWRAP_LIB_INSTALL_DIR}")

# Install wrapping scripts as binaries to `CMAKE_INSTALL_PREFIX/bin` so they can
# be invoked for wrapping. We use DESTINATION (instead of TYPE) so we can
# support older CMake versions.
install(PROGRAMS scripts/pybind_wrap.py scripts/matlab_wrap.py
        DESTINATION "${GTWRAP_BIN_INSTALL_DIR}")

# Install the matlab.h file to `CMAKE_INSTALL_PREFIX/lib/gtwrap/matlab.h`.
install(FILES matlab.h DESTINATION "${GTWRAP_INCLUDE_INSTALL_DIR}")

string(ASCII 27 Esc)
set(gtwrap "${Esc}[1;36mgtwrap${Esc}[m")
message(STATUS "${gtwrap} Package config : ${GTWRAP_CMAKE_INSTALL_DIR}")
message(STATUS "${gtwrap} version        : ${PROJECT_VERSION}")
message(STATUS "${gtwrap} CMake path     : ${GTWRAP_CMAKE_INSTALL_DIR}")
message(STATUS "${gtwrap} library path   : ${GTWRAP_LIB_INSTALL_DIR}")
message(STATUS "${gtwrap} binary path    : ${GTWRAP_BIN_INSTALL_DIR}")
message(STATUS "${gtwrap} header path    : ${GTWRAP_INCLUDE_INSTALL_DIR}")

=== gtsam/base/CMakeLists.txt ===
# Install headers
file(GLOB base_headers "*.h")
install(FILES ${base_headers} DESTINATION include/gtsam/base)

file(GLOB base_headers_tree "treeTraversal/*.h")
install(FILES ${base_headers_tree} DESTINATION include/gtsam/base/treeTraversal)

# Build tests
add_subdirectory(tests)

=== gtsam/sam/CMakeLists.txt ===
# Install headers
file(GLOB sam_headers "*.h")
install(FILES ${sam_headers} DESTINATION include/gtsam/sam)

# Build tests
add_subdirectory(tests)

## gtsam 4.2~9+dfsg

=== debian/changelog ===
gtsam (4.2~9+dfsg-5) unstable; urgency=medium

  * Build fixes on various arches

 -- Dima Kogan <dkogan@debian.org>  Tue, 15 Aug 2023 22:24:33 -0700

gtsam (4.2~9+dfsg-4) unstable; urgency=medium

  * Bug fix in attempt to fix out-of-memory builds on 32-bit arches

 -- Dima Kogan <dkogan@debian.org>  Mon, 14 Aug 2023 09:24:45 -0700

gtsam (4.2~9+dfsg-3) unstable; urgency=medium

  * Attempt to fix out-of-memory builds on 32-bit arches

 -- Dima Kogan <dkogan@debian.org>  Mon, 14 Aug 2023 01:08:19 -0700

gtsam (4.2~9+dfsg-2) unstable; urgency=medium

  * Initial release (Closes: #1031098)

 -- Dima Kogan <dkogan@debian.org>  Wed, 09 Aug 2023 18:03:21 -0700

=== debian/control ===
Source: gtsam
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               dh-python,
               cmake,
               libboost-filesystem-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libboost-program-options-dev,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libeigen3-dev,
               libgeographiclib-dev,
               libspectra-dev,
               libsuitesparse-dev,
               libmetis-dev,
               libtbb-dev,
               pybind11-dev,
               python3-all-dev:any,
               libpython3-all-dev,
               python3-pyparsing,
               python3-numpy,
               chrpath
Build-Depends-Indep: 
               lyx,
               texlive-latex-base,
               ghostscript,
               doxygen
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: http://www.gtsam.org
Vcs-Git: https://salsa.debian.org/science-team/gtsam.git
Vcs-Browser: https://salsa.debian.org/science-team/gtsam

Package: libgtsam4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Factor graphs for sensor fusion in robotics
 GTSAM is a C++ library that implements sensor fusion for robotics and computer
 vision applications, including SLAM (Simultaneous Localization and Mapping), VO
 (Visual Odometry), and SFM (Structure from Motion). It uses factor graphs and
 Bayes networks as the underlying computing paradigm rather than sparse matrices
 to optimize for the most probable configuration or an optimal plan. Coupled
 with a capable sensor front-end (not provided here), GTSAM powers many
 impressive autonomous systems, in both academia and industry.

Package: libgtsam-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libgtsam4 (= ${binary:Version})
Recommends: libgtsam-doc
Description: Factor graphs for sensor fusion in robotics
 GTSAM is a C++ library that implements sensor fusion for robotics and computer
 vision applications, including SLAM (Simultaneous Localization and Mapping), VO
 (Visual Odometry), and SFM (Structure from Motion). It uses factor graphs and
 Bayes networks as the underlying computing paradigm rather than sparse matrices
 to optimize for the most probable configuration or an optimal plan. Coupled
 with a capable sensor front-end (not provided here), GTSAM powers many
 impressive autonomous systems, in both academia and industry.
 .
 Development files

Package: libgtsam-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax
Description: Factor graphs for sensor fusion in robotics
 GTSAM is a C++ library that implements sensor fusion for robotics and computer
 vision applications, including SLAM (Simultaneous Localization and Mapping), VO
 (Visual Odometry), and SFM (Structure from Motion). It uses factor graphs and
 Bayes networks as the underlying computing paradigm rather than sparse matrices
 to optimize for the most probable configuration or an optimal plan. Coupled
 with a capable sensor front-end (not provided here), GTSAM powers many
 impressive autonomous systems, in both academia and industry.
 .
 Documentation

Package: python3-gtsam
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libgtsam4 (= ${binary:Version}),
         ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: Factor graphs for sensor fusion in robotics
 GTSAM is a C++ library that implements sensor fusion for robotics and computer
 vision applications, including SLAM (Simultaneous Localization and Mapping), VO
 (Visual Odometry), and SFM (Structure from Motion). It uses factor graphs and
 Bayes networks as the underlying computing paradigm rather than sparse matrices
 to optimize for the most probable configuration or an optimal plan. Coupled
 with a capable sensor front-end (not provided here), GTSAM powers many
 impressive autonomous systems, in both academia and industry.
 .
 Python library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Build workaround to allow this to build on 32-bit arches.
#   https://lists.debian.org/debian-devel/2023/08/msg00156.html
# This makes the build much slower, but is needed for most arches. I needed to
# ALSO disable debug symbols and optimization for the python wrapper (-O0 -g0;
# set in the no-optimization-or-debug-flags-in-python-bindings.patch).
export DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=5

# When building with gcc-13 (possibly with older ones as well) I get lots of
# these warnings. They are maybe helpful for upstream, but not at all helpful
# for Debian builds, so I disable these
export DEB_CXXFLAGS_MAINT_APPEND += -Wno-deprecated-declarations -Woverloaded-virtual

# On some arches ld says:
#   /usr/bin/ld: CMakeFiles/SolverComparer.dir/SolverComparer.cpp.o: undefined reference to symbol '__atomic_load_8@@LIBATOMIC_1.0'
ifneq (,$(filter $(DEB_HOST_ARCH), armel powerpc sh4))
export DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

# On some arches there's simply too much debugging info. I turn it off. The
# build log says:
#   /usr/bin/ld: error: libgtsam.so.4.2.0(.debug_info) is too large (0x10e67cac bytes)
ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif



ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS   := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@ --with python3 --buildsystem=cmake

# I'm buliding without gtsam_unstable:
# https://github.com/borglab/gtsam/issues/1457
override_dh_auto_configure:
	dh_auto_configure --					\
		-DCMAKE_BUILD_TYPE=RelWithDebInfo		\
		-DGTSAM_BUILD_WITH_MARCH_NATIVE=OFF		\
		-DGTSAM_BUILD_TYPE_POSTFIXES=OFF		\
		-DGTSAM_BUILD_UNSTABLE=OFF			\
		-DGTSAM_UNSTABLE_BUILD_PYTHON=OFF		\
		-DGTSAM_UNSTABLE_INSTALL_MATLAB_TOOLBOX=OFF	\
		-DBUILD_SHARED_LIBS=ON				\
		-DGTSAM_WITH_TBB=ON				\
		-DGTSAM_WITH_EIGEN_MKL=OFF			\
		-DGTSAM_WITH_EIGEN_MKL_OPENMP=OFF		\
		-DGTSAM_BUILD_PYTHON=ON				\
		-DGTSAM_INSTALL_MATLAB_TOOLBOX=OFF		\
		-DGTSAM_ALLOW_DEPRECATED_SINCE_V42=ON		\
		-DGTSAM_BUILD_WITH_CCACHE=OFF			\
		-DGTSAM_USE_SYSTEM_EIGEN=ON			\
		-DGTSAM_USE_SYSTEM_METIS=ON

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))

# I build the lyx and doxygen docs. And I use the local packaged mathjax instead
# of the internet one
override_dh_auto_build-indep:
	lyx -userdir /tmp -e pdf $(filter-out %/macros.lyx,$(wildcard doc/*.lyx))
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) doc
	perl -p -i -e 's{http.*?/MathJax\.js}{file:///usr/share/javascript/mathjax/MathJax.js?config=TeX-MML-AM_CHTML}g' doc/html/*.html

override_dh_compress:
	dh_compress -O--buildsystem=cmake -X.pdf

else

override_dh_auto_build-indep:
	true

endif



ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

override_dh_auto_test:
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE)        check
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE)/python python-test
else

override_dh_auto_test:
	true

endif


# /usr/include/gtwap just has matlab stuff today so I get rid of it
#
# We're supposed to "make python-install" to install this stuff: https://github.com/borglab/gtsam/issues/1513
# But it doesn't work: it uses pip, and is hard-coded to install into the
# system, not to a subdirectory
#
# I can use setup.py instead:
#
#   python3 obj-$(DEB_HOST_GNU_TYPE)/python/setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
#
# But this doesn't work either: setup.py isn't defined properly, or something,
# and it installs the metadata only, but not any of the actual library. So I
# just copy the needed files myself
override_dh_auto_install:
	dh_auto_install -O--buildsystem=cmake

	mkdir -p $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages/gtsam
	cp    obj-$(DEB_HOST_GNU_TYPE)/python/gtsam/*.so  $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages/gtsam
	cp    obj-$(DEB_HOST_GNU_TYPE)/python/gtsam/*.py  $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages/gtsam
	cp -r obj-$(DEB_HOST_GNU_TYPE)/python/gtsam/utils $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages/gtsam

	rm -rf debian/tmp/usr/include/CppUnitLite
	rm -rf debian/tmp/usr/lib/*/libCppUnitLite.a
	rm -rf debian/tmp/usr/include/gtwrap

	chrpath -d debian/tmp/usr/lib/python3/dist-packages/*/*.so

# remove bogus executable bits, remove files I shouldn't ship
override_dh_installexamples-indep:
	dh_installexamples -O--buildsystem=cmake
	find debian/libgtsam-doc/usr/share/doc/libgtsam-dev/examples/Data/ -type f | xargs chmod a-x
	rm debian/libgtsam-doc/usr/share/doc/libgtsam-dev/examples/Data/.gitignore

## gtsam 4.2.0%2Bdfsg

=== debian/changelog ===
gtsam (4.2.0+dfsg-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 19:39:30 +0000

gtsam (4.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Successful build against boost 1.83 (Closes: #1056078)
  * Not depending on the -all python packages (Closes: #1055683)

 -- Dima Kogan <dkogan@debian.org>  Mon, 08 Jan 2024 21:51:35 -0800

gtsam (4.2~9+dfsg-6) unstable; urgency=medium

  * Disabled building examples to cut down on build time
  * Build fixes for 32bit arches

 -- Dima Kogan <dkogan@debian.org>  Thu, 31 Aug 2023 13:32:38 -0700
